crashpad::internal::ExceptionSnapshotWin Class Referencefinal
Inheritance diagram for crashpad::internal::ExceptionSnapshotWin:

## Public Member Functions

bool | Initialize (ProcessReaderWin *process_reader, DWORD thread_id, WinVMAddress exception_pointers)
| Initializes the object. More...
const CPUContext * | Context () const override
| Returns a CPUContext object corresponding to the exception thread’s CPU context at the time of the exception. More...
uint64_t | ThreadID () const override
| Returns the thread identifier of the thread that triggered the exception. More...
uint32_t | Exception () const override
| Returns the top-level exception code identifying the exception. More...
uint32_t | ExceptionInfo () const override
| Returns the second-level exception code identifying the exception. More...
uint64_t | ExceptionAddress () const override
| Returns the address that triggered the exception. More...
const std::vector< uint64_t > & | Codes () const override
| Returns a series of operating system-specific exception codes. More...
std::vector< const MemorySnapshot * > | ExtraMemory () const override
| Returns a vector of additional memory blocks that should be included in a minidump. More...

## Member Function Documentation

## Codes()

const std::vector< uint64_t > & crashpad::internal::ExceptionSnapshotWin::Codes | ( |  | ) | const

overridevirtual

Returns a series of operating system-specific exception codes.

The precise interpretation of these codes is specific to the snapshot operating system. These codes may provide a duplicate of information available elsewhere, they may extend information available elsewhere, or they may not be present at all. In this case, an empty vector will be returned.

For macOS, this will be a vector containing the original exception type and the values of `code[0]` and `code[1]` as received by a Mach exception handler.

For Windows, these are additional arguments (if any) as provided to `RaiseException()`. See the documentation for `ExceptionInformation` in `EXCEPTION_RECORD`.

Implements crashpad::ExceptionSnapshot.

## Context()

const CPUContext * crashpad::internal::ExceptionSnapshotWin::Context | ( |  | ) | const

overridevirtual

Returns a CPUContext object corresponding to the exception thread’s CPU context at the time of the exception.

The caller does not take ownership of this object, it is scoped to the lifetime of the ThreadSnapshot object that it was obtained from.

Implements crashpad::ExceptionSnapshot.

## Exception()

uint32_t crashpad::internal::ExceptionSnapshotWin::Exception | ( |  | ) | const

overridevirtual

Returns the top-level exception code identifying the exception.

This is an operating system-specific value.

For macOS, this will be an EXC_* exception type, such as `EXC_BAD_ACCESS`. `EXC_CRASH` will not appear here for exceptions processed as `EXC_CRASH` when generated from another preceding exception: the original exception code will appear instead. The exception type as it was received will appear at index 0 of Codes().

For Windows, this will be an `EXCEPTION_*` exception type, such as `EXCEPTION_ACCESS_VIOLATION`.

Implements crashpad::ExceptionSnapshot.

## ExceptionAddress()

uint64_t crashpad::internal::ExceptionSnapshotWin::ExceptionAddress | ( |  | ) | const

overridevirtual

Returns the address that triggered the exception.

This may be the address that caused a fault on data access, or it may be the instruction pointer that contained an offending instruction. For exceptions where this value cannot be determined, it will be `0`.

For macOS, this will be the value of the exception code at index 1 as received by a Mach exception handler.

Implements crashpad::ExceptionSnapshot.

## ExceptionInfo()

uint32_t crashpad::internal::ExceptionSnapshotWin::ExceptionInfo | ( |  | ) | const

overridevirtual

Returns the second-level exception code identifying the exception.

This is an operating system-specific value.

For macOS, this will be the value of the exception code at index 0 as received by a Mach exception handler, except:

- For `EXC_CRASH` exceptions generated from another preceding exception, the original exception code will appear here, not the code as received by the Mach exception handler.
- For `EXC_RESOURCE` and `EXC_GUARD` exceptions, the high 32 bits of the exception code at index 0 will appear here.

In all cases on macOS, the full exception code at index 0 as it was received will appear at index 1 of Codes().

On Windows, this will either be `0` if the exception is continuable, or `EXCEPTION_NONCONTINUABLE` to indicate a noncontinuable exception.

Implements crashpad::ExceptionSnapshot.

## ExtraMemory()

std::vector< const MemorySnapshot * > crashpad::internal::ExceptionSnapshotWin::ExtraMemory | ( |  | ) | const

overridevirtual

Returns a vector of additional memory blocks that should be included in a minidump.

Returns
  A vector of MemorySnapshot objects that will be included in the crash dump. The caller does not take ownership of these objects, they are scoped to the lifetime of the ThreadSnapshot object that they were obtained from.

Implements crashpad::ExceptionSnapshot.

## Initialize()

bool crashpad::internal::ExceptionSnapshotWin::Initialize | ( | ProcessReaderWin * | process_reader,
|  | DWORD | thread_id,
|  | WinVMAddress | exception_pointers
| ) |  |

Initializes the object.

Parameters

  [in] | process_reader | A ProcessReaderWin for the process that sustained the exception.
  [in] | thread_id | The thread ID in which the exception occurred.
  [in] | exception_pointers | The address of an `EXCEPTION_POINTERS` record in the target process, passed through from the exception handler.

Note
  If the exception was triggered by CrashpadClient::DumpAndCrashTargetProcess(), this has the side-effect of correcting the thread suspend counts for process_reader.

Returns
  `true` if the snapshot could be created, `false` otherwise with an appropriate message logged.

## ThreadID()

uint64_t crashpad::internal::ExceptionSnapshotWin::ThreadID | ( |  | ) | const

overridevirtual

Returns the thread identifier of the thread that triggered the exception.

This value can be compared to ThreadSnapshot::ThreadID() to associate an ExceptionSnapshot object with the ThreadSnapshot that contains a snapshot of the thread that triggered the exception.

Implements crashpad::ExceptionSnapshot.

The documentation for this class was generated from the following files:

- snapshot/win/exception_snapshot_win.h
- snapshot/win/exception_snapshot_win.cc